// Common Functions for SpXZeigR
// This works with SpXZeigR 4.0
// date: 20.July.07

#pragma rtGlobals=1
#pragma IgorVersion=6.0
#pragma version=4.00

Function/S xzFolderList(how)
	variable how

	string dflist, objName=""
	variable ic = 0

	if (how==0)
		dflist = "Create New;-;root;"
	else
		dflist = "From Load;-;root;"
	endif
	
	do
		objName = GetIndexedObjName("root:", 4, ic)
		if (strlen(objName) == 0)
			break
		else
			if (cmpstr(objName,"Packages")!=0)
				dflist += objName + ";"
			endif
		endif
		ic += 1
	while(1)
	
	return dflist
end

Function/S xzSpectraList(how)
	variable how

	SVAR dff = root:Packages:SpXZeigR:DataPanelParams:displayfromfolder
	
	string slist, cdf="", wlist
	if (how==0)
		slist="All;Match WildCard;-;"
	else
		slist=""
	endif
	
	cdf = GetDataFolder(1)
	SetDataFolder root:
	if (cmpstr(dff,"root")==0)
		wlist = WaveList("*",";","DIMS:1")
	else
		SetDataFolder $dff
		wlist =  WaveList("*",";","DIMS:1")
	endif
	SetDataFolder $cdf
	
	if (strlen(wlist)==0)
		slist = "(no spectra);"
	else
		slist +=wlist
	endif
	
	return slist
	
end

Function/S xzGraphModesList()

	string sloc = "root:Packages:SpXZeigR:GraphParams:GraphModes"
	
	return xzListDir(sloc)
end

Function/S xzRenameInputList()

	SVAR lFN = root:Packages:SpXZeigR:DataPanelParams:loadfunctionname
	
	return (udFLQuerysetNames(lFN))
end

Function/S xzSpectrumTypesList()

	string sloc = "root:Packages:SpXZeigR:GraphParams:SpectrumTypes"
	
	return xzListDir(sloc)

end

Function/S xzListDir(sloc)
	string sloc
	
	string slist = "", objName=""
	variable ic = 0
	do
		objName = GetIndexedObjName(sloc,3,ic)
		if (strlen(objName)==0)
			break
		endif
		slist += objName + ";"
		ic+=1
	while(1)
	
	return slist
	
end

Function/S xzMultiTraceMenu()

	string mtm =""
	
	if (strlen(WinList("*",";","WIN:1"))==0)
		mtm = "All on New;\\M1(All on TopMost;Each Separate;"
	else
		mtm = "All on New;All on TopMost;Each Separate;"
	endif
	return mtm

end

Function/S xzGetSpectrumTypeParam(type,param)
	variable type
	string param
	
	string stype
	
	stype = StringFromList(type-1,xzSpectrumTypesList())
	string sloc = "root:Packages:SpXZeigR:GraphParams:SpectrumTypes:" + stype
	
	SVAR st = $sloc
	
	return (StringByKey(param,st,"="))

end


Function/S xzGetGraphModeParam(mode,param)
	variable mode
	string param
	
	string smode
	
	smode = StringFromList(mode-1,xzGraphModesList())
	string sloc = "root:Packages:SpXZeigR:GraphParams:GraphModes:" + smode

	SVAR sm = $sloc
	
	return (StringByKey(param,sm,"="))

end
//
//Function/S xzFileLoaderList(how)
//	variable how
//
//	string sfileldr
//	
//	sfileldr =FunctionList("udFileLoader*",";","KIND:6")
//	if (how==1)
//		sfileldr =ReplaceString("udFileLoader",sfileldr,"")
//	endif
//	return sfileldr
//
//End

Function/S xzFileLoaderModeList()

	SVAR lFN = root:Packages:SpXZeigR:DataPanelParams:loadfunctionname
	
	return (udFLQueryprocModes(lFN))

End

Function xzGetFilesInDataDirPath(lfname)
	string lfname

	wave/T flist = root:Packages:SpXZeigR:DataPanelParams:filesindatapath
	wave nlist =root:Packages:SpXZeigR:DataPanelParams:nfilesindatapath

	STRUCT udFLStandardStructure udFL
	udFLInitializeLoader(udFL,lfname)
	
	string mimetype = udFL.mimetype
	string filetypes = udFL.extensions
	
	string lofiles = "", nlof = ""
	variable nfiles, ic, ntypes
	
	lofiles = GrepList(IndexedFile(xzDataFiles,-1,"????"),"^\.+",1,";")
	nfiles = ItemsInList(lofiles,";")
	ntypes = ItemsInList(filetypes,";")

	for (ic=0;ic<ntypes;ic+=1)
		nlof += ListMatch(lofiles,("*" + StringFromList(ic,filetypes)))
	endfor
	
	nfiles = ItemsInList(nlof,";")
	redimension/N=(nfiles) flist
	redimension/N=(nfiles) nlist
	flist = StringFromList(p,nlof,";")
	nlist = 0
	
	return 0
end
