// StartUp Routines for SpXZeigR
// This works with SpXZeigR 4.0
// date: 20.July.07

#pragma rtGlobals=1
#pragma IgorVersion=6.0
#pragma version=4.00

// menu builder functions

Function/S xzMainMenuList(itemNumber)
	variable itemNumber

	variable started = NumVarOrDefault("root:Packages:SpXZeigR:Globals:xzstarted",0)

	if (started==0)
		if (itemNumber == 1)
			return xzmenu00
		endif
	else
		switch(itemNumber)
			case 1:
				return xzmenu01
				break
			case 2:
				return (xzmenu02 + "/S1")
		endswitch
	endif
end

// main menu (dynamic)

Menu "SpXZeigR", dynamic
	xzMainMenuList(1), /Q, StartUpSpXZeigR()
	"--"
	xzMainMenuList(2),/Q, xzDataPanelShow(0)
	"--"
	 "About SpXZeigR",/Q
End

// start up / restart function

Function StartUpSpXZeigR()

	string cdf
	variable restart
	
	cdf = GetDataFolder(1)
	
	if (DataFolderExists("root:Packages:SpXZeigR")==0)
	
		// initalize from clean start
		
		NewDataFolder/O/S root:Packages
		NewDataFolder/O/S SpXZeigR
		restart = 0
	else
	
		SetDataFolder root:Packages:SpXZeigR
		restart = 1
	
	endif
	
	xzSettheGlobals()
	xzSettheDataPanelParams()
	xzSettheGraphParams()

	xzAdjustCommandWindow()
	xzDataPanelShow(restart)
	
	SetDataFolder $cdf
	string hstr =  "SpXZeigR (re)Started " + date() + " " + time()
	xzPrintHistory(hstr)
	return 0
End

// Set the globals

Static Function xzSettheGlobals()

	NewDataFolder/O/S Globals
	variable/G xzstarted=1, scrw, scrh, xzsilent = (!xzverbose)
	SetDataFolder root:Packages:SpXZeigR
	return 0
end

Static Function xzSettheDataPanelParams()

	NewDataFolder/O/S DataPanelParams
	
	// display tab globals
	
	string/G displayfromfolder="root", displaywavename=""
	string/G displaywavelist="", displaywildcard=""
	variable/G displaymultitrace=1
	
	// load tab globals
	
	string/G loadfileprefix="",loadtofolder="", loadfunctionname = ""
	string/G loadlistofwavesloaded = "", userData =""
	variable/G loadnameusing=1
	
	make/O/T/n=0 filesindatapath
	make/O/n=0 nfilesindatapath
	if (strlen(xzdatafilespath)!=0)
		NewPath/O/Q xzDataFiles xzdatafilespath
	else
		KillPath/Z xzDataFiles
	endif
	if (strlen(xzstoragefilespath)!=0)
		NewPath/O/Q xzStorageFiles xzstoragefilespath
	else
		KillPath/Z xzStorageFiles
	endif

	// initialize the opening state of the data panel
	
	string/G initialDataPanelMode
	xzInitDataPanelMode()	

	SetDataFolder root:Packages:SpXZeigR
	return 0
End

// Set the graph parameters

Static Function xzSettheGraphParams()

	NewDataFolder/O/S GraphParams
	
	variable/G spectrumtype=1,graphmode=1, ngraphs=0

	NewDataFolder/O/S root:Packages:SpXZeigR:GraphParams:SpectrumTypes
	xzInitSpectrumTypes()

	NewDataFolder/O/S root:Packages:SpXZeigR:GraphParams:GraphModes
	xzInitGraphModes()
	DefaultFont xzDefaultGraphFont

	SetDataFolder root:Packages:SpXZeigR
	return 0
End

// move the command/history window to a convenient location

Static Function xzAdjustCommandWindow()

	NVAR scrw = root:Packages:SpXZeigR:Globals:scrw
	NVAR scrh = root:Packages:SpXZeigR:Globals:scrh
	
	string IgorStuff
	IgorStuff=IgorInfo(0)
	variable scr0,scr1,scr2
	scr0 = strsearch(IgorStuff,"RECT",0)
	scr1 = strsearch(IgorStuff,",",scr0+9)
	scr2 = strlen(IgorStuff)-2
	
	scrw = str2num(IgorStuff[scr0+9,scr1-1])
	scrh = str2num(IgorStuff[scr1+1,scr2])
	
	MoveWindow/C xzWLeftOffset_G*scrw,0.85*scrh,(xzWWidth_G+xzWLeftOffset_G)*scrw,0.95*scrh
End